build-psiphon-framework.sh 8.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238
  1. #!/usr/bin/env bash
  2. # This script takes one optional argument: 'private', if private plugins should
  3. # be used. It should be omitted if private plugins are not desired.
  4. if [[ $1 == "private" ]]; then
  5. FORCE_PRIVATE_PLUGINS=true
  6. echo "TRUE"
  7. else
  8. FORCE_PRIVATE_PLUGINS=false
  9. echo "FALSE"
  10. fi
  11. # -x echos commands. -u exits if an unintialized variable is used.
  12. # -e exits if a command returns an error.
  13. set -x -u -e
  14. # Reset the PATH to macOS default. This is mainly so we don't execute the wrong
  15. # gomobile executable.
  16. PATH=/usr/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/go/bin
  17. BASE_DIR=$(cd "$(dirname "$0")" ; pwd -P)
  18. cd ${BASE_DIR}
  19. # The location of the final framework build
  20. BUILD_DIR="${BASE_DIR}/build"
  21. # Ensure go is installed
  22. which go 2>&1 > /dev/null
  23. if [[ $? != 0 ]]; then
  24. echo "Go is not installed in the path, aborting"
  25. exit 1
  26. fi
  27. VALID_IOS_ARCHS="arm64 armv7 armv7s"
  28. VALID_SIMULATOR_ARCHS="x86_64"
  29. FRAMEWORK="Psi"
  30. INTERMEDIATE_OUPUT_DIR="${BASE_DIR}/PsiphonTunnel/PsiphonTunnel"
  31. INTERMEDIATE_OUPUT_FILE="${FRAMEWORK}.framework"
  32. FRAMEWORK_BINARY="${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}/Versions/A/${FRAMEWORK}"
  33. # The "OPENSSL" tag enables support of OpenSSL for use by IndistinguishableTLS.
  34. PRIVATE_PLUGINS_TAG="PRIVATE_PLUGINS"
  35. if [[ ${FORCE_PRIVATE_PLUGINS} == true ]]; then PRIVATE_PLUGINS_TAG="PRIVATE_PLUGINS"; fi
  36. BUILD_TAGS="IOS ${PRIVATE_PLUGINS_TAG}"
  37. LIBSSL=${BASE_DIR}/OpenSSL-for-iPhone/lib/libssl.a
  38. LIBCRYPTO=${BASE_DIR}/OpenSSL-for-iPhone/lib/libcrypto.a
  39. OPENSSL_INCLUDE=${BASE_DIR}/OpenSSL-for-iPhone/include/
  40. UMBRELLA_FRAMEWORK_XCODE_PROJECT=${BASE_DIR}/PsiphonTunnel/PsiphonTunnel.xcodeproj/
  41. TRUSTED_ROOT_CA_FILE=${BASE_DIR}/PsiphonTunnel/PsiphonTunnel/rootCAs.txt
  42. # Download trustedroot CAs off curl website, see https://curl.haxx.se/docs/caextract.html for details
  43. curl -o $TRUSTED_ROOT_CA_FILE https://curl.haxx.se/ca/cacert.pem
  44. if [[ $? != 0 ]]; then
  45. echo "FAILURE: curl -o $TRUSTED_ROOT_CA_FILE https://curl.haxx.se/ca/cacert.pem"
  46. exit 1
  47. fi
  48. # Exporting these seems necessary for subcommands to pick them up.
  49. export GOPATH=${PWD}/go-ios-build
  50. export PATH=${GOPATH}/bin:${PATH}
  51. # The GOPATH we're using is temporary, so make sure there isn't one from a previous run.
  52. rm -rf ${GOPATH}
  53. GOMOBILE_PINNED_REV=eb9032959f05f108b05721914dfe09cfa0c5131d
  54. GOMOBILE_PATH=${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  55. TUNNEL_CORE_SRC_DIR=${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core
  56. OPENSSL_SRC_DIR=${GOPATH}/src/github.com/Psiphon-Inc/openssl
  57. PATH=${PATH}:${GOPATH}/bin
  58. mkdir -p ${GOPATH}
  59. if [[ $? != 0 ]]; then
  60. echo "FAILURE: mkdir -p ${GOPATH}"
  61. exit 1
  62. fi
  63. # Symlink the current source directory into GOPATH, so that we're building the
  64. # code in this local repo, rather than pulling from Github and building that.
  65. mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs
  66. if [[ $? != 0 ]]; then
  67. echo "mkdir -p ${GOPATH}/src/github.com/Psiphon-Labs"
  68. exit 1
  69. fi
  70. ln -s "${BASE_DIR}/../.." "${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  71. if [[ $? != 0 ]]; then
  72. echo "ln -s ../.. ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core"
  73. exit 1
  74. fi
  75. mkdir -p ${INTERMEDIATE_OUPUT_DIR}
  76. if [[ $? != 0 ]]; then
  77. echo "FAILURE: mkdir -p ${INTERMEDIATE_OUPUT_DIR}"
  78. exit 1
  79. fi
  80. # arg: binary_path
  81. function strip_architectures() {
  82. valid_archs="${VALID_IOS_ARCHS} ${VALID_SIMULATOR_ARCHS}"
  83. ARCHS="$(lipo -info "$1" | rev | cut -d ':' -f1 | rev)"
  84. for ARCH in "${valid_archs}"; do
  85. if ! [[ "${valid_archs}" == *"$ARCH"* ]]; then
  86. echo "Stripping ARCH ${ARCH} from $1"
  87. lipo -remove "$ARCH" -output "$1" "$1"
  88. if [[ $? != 0 ]]; then
  89. echo "FAILURE: lipo $1"
  90. exit 1
  91. fi
  92. fi
  93. done
  94. return 0
  95. }
  96. cd OpenSSL-for-iPhone && ./build-libssl.sh; cd -
  97. strip_architectures "${LIBSSL}"
  98. strip_architectures "${LIBCRYPTO}"
  99. go get -d -u -v -tags "${BUILD_TAGS}" github.com/Psiphon-Inc/openssl
  100. if [[ $? != 0 ]]; then
  101. echo "FAILURE: go get -d -u -v -tags "${BUILD_TAGS}" github.com/Psiphon-Inc/openssl"
  102. exit 1
  103. fi
  104. # Don't use -u, because this path points to our local repo, and we don't want it overridden.
  105. go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  106. if [[ $? != 0 ]]; then
  107. echo "FAILURE: go get -d -v -tags "${BUILD_TAGS}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  108. exit 1
  109. fi
  110. #
  111. # Get and install gomobile, using our pinned revision
  112. #
  113. go get -u golang.org/x/mobile/cmd/gomobile
  114. cd ${GOPATH}/src/golang.org/x/mobile/cmd/gomobile
  115. git checkout master
  116. git checkout -b pinned ${GOMOBILE_PINNED_REV}
  117. go install
  118. ${GOPATH}/bin/gomobile init -v -x
  119. if [[ $? != 0 ]]; then
  120. echo "FAILURE: ${GOPATH}/bin/gomobile init"
  121. exit 1
  122. fi
  123. #
  124. # gomobile bind
  125. #
  126. BUILDDATE=$(date +%Y-%m-%dT%H:%M:%S%z)
  127. BUILDREPO=$(git config --get remote.origin.url)
  128. BUILDREV=$(git rev-parse --short HEAD)
  129. GOVERSION=$(go version | perl -ne '/go version (.*?) / && print $1')
  130. GOMOBILEVERSION=$(${GOPATH}/bin/gomobile version | perl -ne '/gomobile version (.*?) / && print $1')
  131. # see DEPENDENCIES comment in MobileLibrary/Android/make.bash
  132. cd ${GOPATH}/src/github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  133. DEPENDENCIES=$(echo -n "{" && go list -tags "${BUILD_TAGS}" -f '{{range $dep := .Deps}}{{printf "%s\n" $dep}}{{end}}' | xargs go list -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | xargs -I pkg bash -c 'cd $GOPATH/src/pkg && echo -n "\"pkg\":\"$(git rev-parse --short HEAD)\","' | sed 's/,$/}/')
  134. LDFLAGS="\
  135. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildDate=${BUILDDATE} \
  136. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildRepo=${BUILDREPO} \
  137. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.buildRev=${BUILDREV} \
  138. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.goVersion=${GOVERSION} \
  139. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.gomobileVersion=${GOMOBILEVERSION} \
  140. -X github.com/Psiphon-Labs/psiphon-tunnel-core/psiphon/common.dependencies=${DEPENDENCIES} \
  141. "
  142. echo ""
  143. echo "Variables for ldflags:"
  144. echo " Build date: ${BUILDDATE}"
  145. echo " Build repo: ${BUILDREPO}"
  146. echo " Build revision: ${BUILDREV}"
  147. echo " Go version: ${GOVERSION}"
  148. echo " Gomobile version: ${GOMOBILEVERSION}"
  149. echo ""
  150. # Patch source files to build on Darwin
  151. IOS_CGO_BUILD_FLAGS='// #cgo darwin CFLAGS: -I'"${OPENSSL_INCLUDE}"'\
  152. // #cgo darwin LDFLAGS:'"${LIBSSL}"'\
  153. // #cgo darwin LDFLAGS:'"${LIBCRYPTO}"''
  154. LC_ALL=C sed -i -- "s|// #cgo pkg-config: libssl|${IOS_CGO_BUILD_FLAGS}|" "${OPENSSL_SRC_DIR}/build.go"
  155. # We're using a generated-code prefix to workaround https://github.com/golang/go/issues/18693
  156. ${GOPATH}/bin/gomobile bind -v -x -target ios -prefix Go -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi
  157. rc=$?; if [[ $rc != 0 ]]; then
  158. echo "FAILURE: ${GOPATH}/bin/gomobile bind -target ios -tags="${BUILD_TAGS}" -ldflags="${LDFLAGS}" -o "${INTERMEDIATE_OUPUT_DIR}/${INTERMEDIATE_OUPUT_FILE}" github.com/Psiphon-Labs/psiphon-tunnel-core/MobileLibrary/psi"
  159. exit $rc
  160. fi
  161. strip_architectures "${FRAMEWORK_BINARY}"
  162. #
  163. # Do the outer framework build using Xcode
  164. #
  165. # Clean previous output
  166. rm -rf "${BUILD_DIR}"
  167. rm -rf "${BUILD_DIR}-SIMULATOR"
  168. # Build the outer framework for phones...
  169. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphoneos ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}"
  170. rc=$?; if [[ $rc != 0 ]]; then
  171. echo "FAILURE: xcodebuild iphoneos"
  172. exit $rc
  173. fi
  174. # ...and for the simulator.
  175. xcodebuild clean build CODE_SIGN_IDENTITY="" CODE_SIGNING_REQUIRED=NO CODE_SIGN_ENTITLEMENTS="" CODE_SIGNING_ALLOWED="NO" -configuration Release -sdk iphonesimulator ARCHS=x86_64 VALID_ARCHS=x86_64 ONLY_ACTIVE_ARCH=NO -project ${UMBRELLA_FRAMEWORK_XCODE_PROJECT} CONFIGURATION_BUILD_DIR="${BUILD_DIR}-SIMULATOR"
  176. rc=$?; if [[ $rc != 0 ]]; then
  177. echo "FAILURE: xcodebuild iphonesimulator"
  178. exit $rc
  179. fi
  180. # Add the simulator x86_64 binary into the main framework binary.
  181. lipo -create "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel" "${BUILD_DIR}-SIMULATOR/PsiphonTunnel.framework/PsiphonTunnel" -output "${BUILD_DIR}/PsiphonTunnel.framework/PsiphonTunnel"
  182. rc=$?; if [[ $rc != 0 ]]; then
  183. echo "FAILURE: lipo create"
  184. exit $rc
  185. fi
  186. # Delete the temporary simulator build files.
  187. rm -rf "${BUILD_DIR}-SIMULATOR"
  188. # Jenkins loses symlinks from the framework directory, which results in a build
  189. # artifact that is invalid to use in an App Store app. Instead, we will zip the
  190. # resulting build and use that as the artifact.
  191. cd "${BUILD_DIR}"
  192. zip --recurse-paths --symlinks build.zip * --exclude "*.DS_Store"
  193. echo "BUILD DONE"